<?php
/*    
    cleeasy - suporte para rede em aplicativos que rodem via linha de 
              comando facilitado e funcoes para string animada
              
    Copyright (C) 2004  tDs - tds-@brturbo.com
   
    Este programa  software livre; voc pode redistribu-lo e/ou
    modific-lo sob os termos da Licena Pblica Geral GNU, conforme
    publicada pela Free Software Foundation; tanto a verso 2 da
    Licena como (a seu critrio) qualquer verso mais nova.

    Este programa  distribudo na expectativa de ser til, mas SEM
    QUALQUER GARANTIA; sem mesmo a garantia implcita de
    COMERCIALIZAO ou de ADEQUAO A QUALQUER PROPSITO EM
    PARTICULAR. Consulte a Licena Pblica Geral GNU para obter mais
    detalhes.
 
    Voc deve ter recebido uma cpia da Licena Pblica Geral GNU
    junto com este programa; se no, escreva para a Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307, USA.

   +------------------------------------------------------------+
   + classes                                                    +
   +------------------------------------------------------------+
   + file: cleeasy.inc.php                                      +
   +------------------------------------------------------------+
   + Funcoes e classes disponibilizadas                         +
   +------------------------------------------------------------+
*/

    /* configuracoes necessarias */
    define ('NET_ip', '127.0.0.1');    // endereco ip que recebera conexoes
    define ('NET_porta', '10001');     // porta que ficara o aplicativo
    define ('NET_timeout', 10);        // tempo antes de finalizar por timeout
    define ('NET_aplic', 'index.php'); // path para aplicativo que recebera suporte
    define ('NET_aplic_nome', 'eigT'); // nome do aplicativo que recebera suporte
    if (!defined ('NET_using'))
        define ('NET_using', 1);       //informa que vai utilizar suporte a rede
    /* fim de configuracoes */


class cleeasy
{
    /*
        verifica se usuario esta conectado ainda 
    */
    function conectado ()
    {
        if ( socket_last_error () ) {
            
            if ( socket_last_error () != 98) { // endereco em uso
                cleeasy::neteeasy_status(3);
            }
            
            cleeasy::sair ();
        }
            
    }
    
    
    /*
        desconecta usuario do servidor
    */    
    function sair ()
    {
        if ( NET_using == 1 ) {
            socket_close($_SESSION['NET_socket']);
            $_SESSION['NET_socket'] = 'sair';
            $temp = $_SESSION['NET_main_sock'];
            $_SESSION = array();
            $_SESSION['NET_main_sock'] = $temp;
            if ( ! is_resource($temp) ) {
                cleeasy::neteeasy_status(4);
                exit;
            }
                
            socket_clear_error();
            cleeasy::neteeasy_status(3);
            cleeasy::neteeasy (NET_aplic);
        } else {
            exit;
        }
    }
    
    
    /*
        finaliza servidor
    */
    function fim ()
    {
        if ( NET_using == 1 ) 
            socket_close($_SESSION['NET_main_sock']);
        exit;
    }
    
        
    /* 
        void goto (int $linha, int $coluna)
        
        vai para linha $linha e coluna $coluna
    */
    function goto ($linha, $coluna)
    {
        $str = "\033[$linha;$coluna".'H';
        echo $str;
        if ( NET_using == 1 ) {
            cleeasy::conectado ();
            socket_write ( $_SESSION['NET_socket'], $str, strlen ($str) ); 
        }
    }

    

    /*
        void limpar (void)
        
        limpa a tela e posiciona cursor na posicao 
        linha 0 e coluna 0
    */
    function limpar ()
    {
        $str = "\033[2J\033[0;0H";
        echo $str;
        if ( NET_using == 1 ) {
            cleeasy::conectado ();
            socket_write ( $_SESSION['NET_socket'], $str, strlen ($str) );
        }
    }

    
    /* 
        string cores (string $cor)
        
        define a cor do texto como $cor. Caso nao exista a cor $cor,
        sera definida como preto.
    */
    function cores ($cor)
    {
        if ( NET_using == 1 ) 
            cleeasy::conectado ();
        $cores = array ('preto'    => "\033[1;30m",
                        'azul'     => "\033[1;34m",
                        'verde'     => "\033[1;32m",
                        'vermelho' => "\033[1;31m",
                        'amarelo'  => "\033[1;33m",
                        'ciano'  => "\033[1;36m",
                        'branco'   => "\033[1;37m"
                    );
        if (!array_key_exists ($cor, $cores)) {
            $str = "\033[1;37m";
            echo $str;
            
            if ( NET_using == 1 ) 
                socket_write ( $_SESSION['NET_socket'], $str, strlen ($str) );
            
            return (0);
        } else {
            $str = $cores[$cor];
            echo $str;
            
            if ( NET_using == 1 ) 
                socket_write ( $_SESSION['NET_socket'], $str, strlen ($str) );
            
            return (0);
        }
    }




    /* 
        void echoxy (int $linha, int $coluna, string $string)
        
        exibe string na posicao $linha,$coluna 
    */
    function echoxy ($linha, $coluna, $string)
    {
        cleeasy::goto ($linha, $coluna);
        $str = $string;
        echo $str;
        if ( NET_using == 1 ) {
            cleeasy::conectado ();
            socket_write ( $_SESSION['NET_socket'], $str, strlen ($str) );
        }
    }
    
    
    /* 
        void echo_ (string $string)
        
        exibe string na posicao atual do cursor
    */
    function echo_ ($string)
    {
        $str = $string;
        echo $str;
        if ( NET_using == 1 ) {
            cleeasy::conectado ();
            socket_write ( $_SESSION['NET_socket'], $str, strlen ($str) );
        }
    }
    
    /* 
        void fgets (int $tamanho)
        
        Le $tamanho caracteres 
    */
    function fgets_ ($tamanho)
    {
        if ( NET_using == 1 ) {
            cleeasy::conectado ();
            $ler = socket_read ($_SESSION['NET_socket'], $tamanho, PHP_NORMAL_READ);
        } else {
            $ler = fgets (STDIN, $tamanho);
        }
        return ($ler);
    }
    
    /*
        string function chargen ()
        
        retorna um caracter aleatorio
    */
    function chargen ()
    {
        $num = rand (65, 122);
        return (chr ($num));
    }
    
    
    
    /*
        void typewriter (int $linha, int $coluna, string $string,[  bool $reverse = 0, int $speed = 5])
        
        exibe a string $string caracter por caracter, na linha $linha e
        iniciando pela coluna $coluna. Caso $reverse seja diferente de 0,
        inicia a exibicao da string pelo final.
        A velocidade $speed pode ser um valor entre 1 (mais rapido) e 10 (mais lento), sendo 
        padrao o valor 5.
    */
    function typewriter ($linha, $coluna, $string, $reverse = 0, $speed = 5)
    {
        /*
            se $speed for menor que 10 e maior que 0, o valor dele sera multiplicado
            por 25000 (valor utilizado na funcao usleep () ). Caso contrario, o valor
            sera somente 25000.
        */
        $speed = ($speed > 0 && $speed <= 10) ? $speed * 25000 : 25000 * 5;
        
        if (!$reverse) {
            $passos = strlen ($string) + $coluna; 
            $pstring = 0;
        
            for ($cont = $coluna; $cont < $passos; $cont++, $pstring++) {
                cleeasy::echoxy ($linha, $cont, $string[$pstring]);
                cleeasy::echoxy ($linha, $cont+1, '_');
                cleeasy::goto (1000, 1000);
                usleep ($speed);
            }    
            cleeasy::echoxy ($linha, $passos, ' ');
        } else {
            $coluna--;
            $passos = strlen ($string);
            $pstring = $passos - 1;
    
            for ($cont = $coluna + $passos; $cont > $coluna; $cont--, $pstring--) {
                cleeasy::echoxy ($linha, $cont-1, '_');
                cleeasy::echoxy ($linha, $cont, $string[$pstring]);
                cleeasy::goto (1000, 1000);
                usleep ($speed);
            }
        }    
    }

    
    /*
        void randon_string (int $linha, int $coluna, string $string, [int $speed = 5])
        
        exibe a string $string na linha $linha, iniciando pela coluna
        $coluna. A velocidade $speed pode ser um valor entre 1 (mais rapido) 
        e 10 (mais lento).
        Primeiro e' exibida uma string aleatoria de mesmo comprimento de $string
        na posicao indicada. Apos isso, cada caracter vai sendo substituido pelo
        referente a string naquela posicao.
    */
    function randon_string ($linha, $coluna, $string, $speed = 5)
    {
        /*
            se $speed for menor que 10 e maior que 0, o valor dele sera multiplicado
            por 25000 (valor utilizado na funcao usleep () ). Caso contrario, o valor
            sera somente 25000.
        */
        $speed = ($speed > 0 && $speed <= 10) ? $speed * 25000 : 25000 * 5;
        
        $passos  = strlen ($string) + $coluna;
        $pstring = 0;
    
        for ($cont = $coluna; $cont < $passos; $cont++, $pstring++) {
            $num = rand (65, 122);
            cleeasy::echoxy ($linha, $cont, chr ($num) );
        }    
    
        usleep (100000);
        $pstring = 0;
        for ($cont = $coluna; $cont < $passos; $cont++, $pstring++) {
            cleeasy::echoxy ($linha, $cont, $string[$pstring]);
            cleeasy::goto (1000, 1000);
            usleep ($speed);
        }    
    }
    
    
    /*
        void vertical (int $linha, int $coluna,  string $string,[ bool $reverse = 0, int $speed = 5])
        
        exibe a string $string na vertical, iniciando pela linha $linha,
        na coluna $coluna. Caso $reverse seja diferente de 0, comeca a exibicao 
        pelo final.A velocidade $speed pode ser um valor entre 1 (mais rapido) 
        e 10 (mais lento).
    */
    function vertical ($linha, $coluna,  $string, $reverse = 0, $speed = 0)
    {
         /*
            se $speed for menor que 10 e maior que 0, o valor dele sera multiplicado
            por 25000 (valor utilizado na funcao usleep () ). Caso contrario, o valor
            sera somente 25000.
        */
        $speed = ($speed > 0 && $speed <= 10) ? $speed * 25000 : 0;
        
        if (!$reverse) {
            $passos  = strlen ($string) + $linha;
            $pstring = 0;
    
            for ($cont = $linha; $cont < $passos; $cont++, $pstring++) {
                cleeasy::echoxy ($cont, $coluna, $string[$pstring]);
                if ($speed != 0)
                    usleep ($speed);
            }
        } else {
            $linha--;
            $passos  = strlen ($string);
            $pstring = $passos - 1;
    
            for ($cont = $passos + $linha; $cont > $linha; $cont--, $pstring--) {
                cleeasy::echoxy ($cont, $coluna, $string[$pstring]);
                if ($speed != 0)
                    usleep ($speed);
            }
        
        }
    }
    

    
    /*
        void carregando (int $linha, int $coluna, int $tempo)
        
        simula exibe uma barra de progresso na linha $linha,
        iniciando pela coluna $coluna, durante $tempo segundos.
    */
    function carregando ($linha, $coluna, $tempo)
    {
        $tempo = 1000000 * $tempo; 
        $tempo = $tempo / 30;
        $pos   = $coluna + 32;
        $por   = 0;
        
        for ($cont = $coluna; $cont < 30; $cont++, $por++) {
            cleeasy::echoxy ($linha, $cont, '|');
            cleeasy::echoxy ($linha, $pos, round ( (10/3)* $por).'%' );
            cleeasy::goto (1000, 1000);
            usleep ($tempo);
        }    
        cleeasy::echoxy ($linha, $cont, '|');
        cleeasy::echoxy ($linha, $pos, '100%' );
    }

    
    /*
        void updown (int $linha, int $coluna, string $string,[int $speed = 5])
        
        exibe a string $string na linha $linha, iniciando pela coluna
        $coluna. A velocidade $speed pode ser um valor entre 1 (mais rapido) 
        e 10 (mais lento).
        Inicia-se caido caracteres aleatorios 4 linhas acima e subindo caracteres 
        aleatorios 4 linhas abaixo. Quando eles se encontram, exibe o caracter definitivo
        daquela posicao
    */
    function updown ($linha, $coluna, $string, $speed = 5)
    {
         /*
            se $speed for menor que 10 e maior que 0, o valor dele sera multiplicado
            por 25000 (valor utilizado na funcao usleep () ). Caso contrario, o valor
            sera somente 25000.
        */
        $speed = ($speed > 0 && $speed <= 10) ? $speed * 25000 : 0;
        $pstring = 0;
        
        /* loop principal, exibicao da string */
        for ($cont = $coluna; $cont < strlen ($string) + $coluna; $cont++, $pstring++) {
            $linha_acima  = $linha + 5;
            $linha_abaixo = $linha - 5;
            
            /* loop secundario, exibe caracters caindo e subindo */
            for ($contsec = 0; $contsec <= 4; $contsec++, $linha_abaixo++, $linha_acima--) {
                $caracter1 = cleeasy::chargen ();
                $caracter2 = cleeasy::chargen ();
                cleeasy::vertical ($linha_acima,  $cont, $caracter1);
                cleeasy::vertical ($linha_abaixo, $cont, $caracter2);
                cleeasy::goto (1000, 1000);
                usleep ($speed);
                cleeasy::vertical ($linha_acima,  $cont, ' ');
                cleeasy::vertical ($linha_abaixo, $cont, ' ');
            }
            cleeasy::echoxy ($linha, $cont, $string[$pstring]);
        }
    }
    
    
    /*
        void limpar_linha (int $linha, int $inicio, int $fim, [int $speed])
        limpa linha $linha, iniciando em $inicio e terminando em $fim, na velocidade
        determinada por $speed. A velocidade $speed pode ser um valor entre 1 (mais rapido) 
        e 10 (mais lento). Caso $inicio for maior que $fim, a operacao sera feita inciando pelo
        fim
    */
    function limpar_linha ($linha, $inicio, $fim, $speed = 0)
    {
         /*
            se $speed for menor que 10 e maior que 0, o valor dele sera multiplicado
            por 25000 (valor utilizado na funcao usleep () ). Caso contrario, o valor
            sera somente 25000.
        */
        $speed = ($speed > 0 && $speed <= 10) ? $speed * 25000 : 0;
        
        if ($inicio < $fim) {
            for ($cont = $inicio; $cont < $fim; $cont++) {
                cleeasy::echoxy ($linha, $cont, '>');
                cleeasy::goto (1000, 1000);
                if ($speed)
                    usleep ($speed);
                cleeasy::echoxy ($linha, $cont, ' ');
            }
        } else {
            for ($cont = $inicio; $cont > $fim; $cont--) {
                cleeasy::echoxy ($linha, $cont, '<');
                cleeasy::goto (1000, 1000);
                if ($speed)
                    usleep ($speed);
                cleeasy::echoxy ($linha, $cont, ' ');
            }
        }
    }
    
    /*
        coloca suporte a rede no aplicativo $arquivo
    */
    function neteeasy ($arquivo)
    {
        $socket = $_SESSION['NET_main_sock'];
        do {
            if ( ( $con_in = socket_accept ( $socket ) ) < 0 )   { cleeasy::neteeasy_erro ( 4, $con_in ); }
            $_SESSION['NET_socket'] = $con_in;
            cleeasy::limpar ();
            cleeasy::neteeasy_status(2);
            cleeasy::typewriter (8, 2, 'Iniciando '.NET_aplic_nome, 0, 1);
            sleep (1);
            cleeasy::limpar ();
            do {
                /* ---------------------------------------- inicio do codigo efetivo */
                include $arquivo;
                /* ---------------------------------------- fim do codigo efetivo */
                if ($_SESSION['NET_socket'] == 'sair') { break; }
                if ($_SESSION['NET_socket'] == 'fim') { socket_close($msgsock); break 2; }
            } while (true);
            socket_close($con_in);
        } while (true);
        socket_close($socket);
    }

    private function neteeasy_status ($cod)
    {
      $str = "\033[2J\033[0;0H";
      if ($cod == 1) {
            echo $str.
                ",----------------------------------------\n\r".
                "| Servidor inicializado...\n\r|\n\r".
                "| Porta           : ".NET_porta."\n\r".
                "| Endereco ip     : ".NET_ip."\n\r".
                "| Aplicativo      : ".NET_aplic_nome."\n\r".
                "| Status          : Aguardando conexao\n\r".
                "`----------------------------------------\n\r";
        }        
        if ($cod == 2) {
            socket_getpeername ($_SESSION['NET_socket'], $ip_remoto, $porta_remota);
            cleeasy::echo_ ($str.
                 ",----------------------------------------\n\r".
                 "| Recebendo conexao.                     \n\r|\n\r".
                 "| Endereco remoto : $ip_remoto           \n\r".
                 "| Porta remota    : $porta_remota        \n\r".
                 "| Status          : Conectado!           \n\r".
                 "`----------------------------------------\n\r");
        }
        if ($cod == 3) {
            sleep (2);
            echo $str.
                 ",----------------------------------------\n\r".
                 "| Usuario desconectou.                   \n\r|\n\r".
                 "| Reinicializando servidor...            \n\r".
                 "`----------------------------------------\n\r";
            sleep (1);
            cleeasy::neteeasy_status(1);
        }
        
        if ($cod == 4) {
            echo $str.
                 ",----------------------------------------\n\r".
                 "| Ocorreu um erro ao iniciar o servidor:  \n\r".
                 "| ( ".socket_strerror (socket_last_error())." )\n\r".
                 "| Tente novamente em alguns segundos.    \n\r".
                 "`----------------------------------------\n\r";
        }
        
    }
    
    /*
        cria socket para ser utilizado com o neteeasy()
    */
    function criar_socket ()
    {
        
        if ( ($socket = socket_create_listen (NET_porta, 10)) < 0) { cleeasy::neteeasy_erro ( 3, $con_in ); }
        cleeasy::neteeasy_status (1);
        $_SESSION['NET_main_sock'] = $socket;
        return ($socket);
    }

    /*
        mensagem de erros oriundas de neteeasy()
    */
    function neteeasy_erro ($codigo, $argumentos = 0)
    {
        switch ($codigo) {
            case (1):
                //echo 'Erro ao criar socket: ' . socket_strerror($sock) . "\n";
                die;
                break;
            case (2):
                //echo "socket_bind() failed: reason: " . socket_strerror($ret) . "\n";
                die;
                break;
            case (3);
                //echo $socket = socket_create_listen (NET_porta, 10)
                die;
                break;
            case (4);
                //echo "socket_accept() failed: reason: " . socket_strerror($msgsock) . "\n";
                die;
                break;
            case (5);
                //echo "socket_read() failed: reason: " . socket_strerror($ret) . "\n";
                die;
                break;
        }
    }
    
}
cleeasy::conectado ();
?>
