<?php
/*    
    eigT - Quebra-Cabecas de pecas deslizantes de 8 pecas.
    Copyright (C) 2004  tDs - tds-@brturbo.com
   
    Este programa  software livre; voc pode redistribu-lo e/ou
    modific-lo sob os termos da Licena Pblica Geral GNU, conforme
    publicada pela Free Software Foundation; tanto a verso 2 da
    Licena como (a seu critrio) qualquer verso mais nova.

    Este programa  distribudo na expectativa de ser til, mas SEM
    QUALQUER GARANTIA; sem mesmo a garantia implcita de
    COMERCIALIZAO ou de ADEQUAO A QUALQUER PROPSITO EM
    PARTICULAR. Consulte a Licena Pblica Geral GNU para obter mais
    detalhes.
 
    Voc deve ter recebido uma cpia da Licena Pblica Geral GNU
    junto com este programa; se no, escreva para a Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307, USA.

   +------------------------------------------------------------+
   + Funcoes do jogo                                            +
   +------------------------------------------------------------+
   + file: funcoes.inc.php                                      +
   +------------------------------------------------------------+
   + Engine do jogo se encontra nesta classe. Nenhuma outra     +
   + funcao e' exportada (somente a classe).                    +
   +------------------------------------------------------------+
*/

class eigt
{
    function inicio ($posicoes = 0)
    {
        /*
            caso esteja inicialiazando jogo, cria as posicoes de cada bloco.
            caso contrario, apenas seta variavel $posicoes com o valor de
            cada posicao
        */
        if ($_SESSION['EIG_iniciado'] == 0) {
            if (!$posicoes || sizeof($posicoes) != 9) {
                $posicoes = array (1, 2, EIG_VAZIO, 3, 4, 5, 6, 7, 8);
                shuffle ($posicoes);
                array_unshift($posicoes, 0);
            }
            
            $_SESSION['EIG_posicoes'][0]  = 0;
            $_SESSION['EIG_objetivo']     = array (0, 1, 2, 3, 4, 5, 6, 7, 8);
            $_SESSION['EIG_final']        = EIG_NAO;
            $_SESSION['EIG_movimentos']   = 1;
            $_SESSION['EIG_iniciado']     = 0;
        
        } else {
            $posicoes = $_SESSION['EIG_inicial'];
        }
    
        /* caso necessario criar posicoes manualmente, utilize este linha */
        //$posicoes = array ( 0, 1,  2, 3,  4,  5, 8,   6,    7,  EIG_VAZIO );
        
        $_SESSION['EIG_posicoes']  = $posicoes;                 // posicao de cada peca 
        $_SESSION['EIG_inicial']   = $_SESSION['EIG_posicoes']; // posicao inicial de todas as pecas
        $_SESSION['EIG_vazio']     = eigt::vazio ();            // obtem posicao vazia
        $_SESSION['EIG_anterior']  = eigt::vazio ();            // posicao do quadrado vazio anteriormente
        eigt::movimentos_validos ();                              // inicializa movimentos validos
        
        
        /* caso esteja iniciando jogo (primeira chamada a funcao) */
        if ($_SESSION['EIG_iniciado'] == 0) {
            grafico::tabuleiro ();                        //desenha o tabuleiro
            
            $cont = 1;
            foreach ($posicoes as $posicao) {
                if ($posicao === 0) continue;
                if ($posicao === EIG_VAZIO) {
                    $cont++;
                    continue;
                }
                grafico::coloca_peca ($cont, $posicao);    //coloca blocos no tabuleiro
                $cont++;
            }

            if (EIG_MODO == 1) {
                cleeasy::vertical (2, 23, 'VOCE ESTA');
                cleeasy::vertical (2, 26, 'NO JOGO');
            }
            $_SESSION['EIG_iniciado'] = 1;    //informa que jogo ja iniciou
        }
    }
    
    
    
    
    function objetivo ()
    {
        $objetivo = $_SESSION['EIG_objetivo'];
        $posicoes = $_SESSION['EIG_posicoes'];
    
        $vazio    = $_SESSION['EIG_vazio']; // localiza a posicao vazia
        unset ($posicoes[$vazio]);          // e remove-a
        
        /* reorganiza as posicoes, apos remocao da posicao VAZIO */
        $cont = 0;
        foreach ($posicoes as $corrente) {
            $temp[$cont] = $corrente;
            $cont++;
        }
        $posicoes = $temp;
        
        /* compara as posicoes atuais com o objetivo e informa se esta correto */
        for ($cont = 1; $cont != 8; $cont++) {
            if ($posicoes[$cont] != $objetivo[$cont]) return (EIG_NAO);
        }
        
        $_SESSION['EIG_final'] = EIG_SIM;
        return (EIG_SIM);
    }
    
    
    
    
    function vazio ()
    {
        $vazio = array_search (EIG_VAZIO, $_SESSION['EIG_posicoes'], 1);
        return ($vazio);
    }
    
    
    
    
    function ler_jogada ()
    {
        while (1) {
            cleeasy::limpar_linha (23, 0, 5);
            cleeasy::echoxy(23, 0, ':');
            cleeasy::limpar_linha (24, 0, 5);
            cleeasy::limpar_linha (25, 0, 5);
            cleeasy::goto (23, 2);
            
            $get_posicao = cleeasy::fgets_ (4) ;
            $temp        = str_replace ("\n", '', $get_posicao);
            $temp        = str_replace ("\r", '', $temp);
            
            $get_posicao = str_replace (' ', '', $temp);
            
            if ($get_posicao == 's') eigt::sair();  //digitou 's'
            
            $get_posicao = intval ($get_posicao);
            if ($get_posicao <= 0 || $get_posicao > 9) {
                continue;
            } else {
                return ( $get_posicao );
            }
        }
    }
    
    
    
    
    function posicoes_corretas ()
    {
        $posicoes = $_SESSION['EIG_posicoes'];
        $corretas = 0;
        $corretas = ( $posicoes[1] == 1 || $posicoes[1] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[2] == 1 || $posicoes[2] == 2  || $posicoes[2] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[3] == 2 || $posicoes[3] == 3  || $posicoes[3] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[4] == 3 || $posicoes[4] == 4  || $posicoes[4] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[5] == 4 || $posicoes[5] == 5  || $posicoes[5] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[6] == 5 || $posicoes[6] == 6  || $posicoes[6] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[7] == 6 || $posicoes[7] == 7  || $posicoes[7] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[8] == 7 || $posicoes[8] == 8  || $posicoes[8] == EIG_VAZIO) ? ++$corretas :$corretas;
        $corretas = ( $posicoes[9] == 8 || $posicoes[9] == EIG_VAZIO) ? ++$corretas :$corretas;
        
        $corretas--;
        $_SESSION['EIG_corretas'] = $corretas;
        return ($corretas);
    }
    
    
    
    
    function atualiza_tempo ()
    {
        $inicio = $_SESSION['EIG_tempo_inicial'];
        $agora  = time();
        $passou = $agora - $inicio;
        $_SESSION['EIG_tempo_total'] = $passou;
        return ($passou);
    }
    
    
    
    
    function inicia_tempo ()
    {
        if (! $_SESSION['EIG_tempo_inicial'])        // na primeira rodada, 
            $_SESSION['EIG_tempo_inicial'] = time(); // registra o inicio
    }
    
    
    
    
    function movimentos_validos ()
    {
        $pos    = $_SESSION['EIG_vazio'];
        $adj[1] = array (0, 2, 4);
        $adj[2] = array (0, 1, 3, 5);
        $adj[3] = array (0, 2, 6);
        $adj[4] = array (0, 1, 5, 7);
        $adj[5] = array (0, 2, 4, 6, 8);
        $adj[6] = array (0, 3, 5, 9);
        $adj[7] = array (0, 4, 8);
        $adj[8] = array (0, 5, 7, 9);
        $adj[9] = array (0, 6, 8);
        
        $_SESSION['EIG_movimentos_validos'] = $adj[$pos];
        return ($adj[$pos]);
    }
    
    
    
    
    function traducao ($peca)
    {
        $posicoes = $_SESSION['EIG_posicoes'];
        $pecas    = array_flip($posicoes);
        return ($pecas[$peca]);
    }
    
    
    
    
    function mover ($posicao = 'ia')
    {
        if ( ($posicao <= 0 || $posicao > 9) & $posicao !== "ia" ) 
            return (EIG_NAO);

        $permitidos = eigt::movimentos_validos ();
        $posicoes   = $_SESSION['EIG_posicoes'];
        $vazio      = $_SESSION['EIG_vazio'];
        $posicao    = eigt::traducao ($posicao);
        $proximo    = $posicao;
        
        if (!array_search($posicao, $permitidos)) 
            return (EIG_NAO);
        
        $_SESSION['EIG_anterior'] = $vazio;
        $_SESSION['EIG_vazio']    = $proximo;
    
        /* 
            efetua substituicao do quadrado vazio pela posicao $proximo
            e o quadrado $proximo fica com o valor vazio
        */
        $posicoes[$vazio]         = $posicoes[$proximo];
        $posicoes[$proximo]       = EIG_VAZIO;
        $_SESSION['EIG_posicoes'] = $posicoes;
        $_SESSION['EIG_movimentos']++;
        return (EIG_SIM);
    }
    
    
    
    
    function sair ()
    {
        cleeasy::limpar_linha (23, 0, 5);
        cleeasy::limpar_linha (24, 0, 5);
        cleeasy::goto (24, 0);
        cleeasy::cores ('branco');
        cleeasy::sair();
    }
}
?>
